/* Problem URL: https://codeforces.com/contest/2208/problem/D1 */

#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

template <class T, class comp = less<>>
using ordered_set = tree<T, null_type , comp , rb_tree_tag , tree_order_statistics_node_update>;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (int i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (int i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

const int oo = INT32_MAX >> 1;
const ll OO = INT64_MAX >> 1;


void pre()
{

}

#define TEST 1

void solve()
{
    int n;
    cin >> n;

    V<string> a(n);
    cin >> a;

    vvi graph(n);
    vvi mult(n);
    vvi inv(n);

    rep(i, n) {
        if (a[i][i] != '1') {
            cout << "No\n";
            return;
        }

        rep(j, n) {
            if (i == j) {
                continue;
            }

            if (a[i][j] == '0') {
                continue;
            }

            rep(k, n) {
                if (a[i][k] == '0' && a[j][k] == '1') {
                    cout << "No\n";
                    return;
                }
            }

            graph[i].push_back(j);
            inv[j].push_back(i);
            mult[i].push_back(j);
            mult[j].push_back(i);
        }
    }

    vi st;
    V<bool> frame(n);
    V<bool> vis(n);

    function<bool(int)> dfs = [&](int i) {
        vis[i] = true;
        frame[i] = true;

        repv(j, graph[i]) {
            if (frame[j]) {
                return false;
            }

            if (vis[j]) {
                continue;
            }

            if (!dfs(j)) {
                return false;
            }
        }

        st.push_back(i);

        frame[i] = false;
        return true;
    };

    function<void(int)> dfs2 = [&](int i) {
        vis[i] = true;
        repv(j, mult[i]) {
            if (vis[j]) {
                continue;
            }

            dfs2(j);
        }
    };

    rep(i, n) {
        if (vis[i]) {
            continue;
        }

        if (!dfs(i)) {
            cout << "No\n";
            return;
        }
    }

    fill(all(vis), false);
    dfs2(0);


    rep(i, n) {
        if (!vis[i]) {
            cout << "No\n";
            return;
        }
    }

    V<V<bool>> rem(n, V<bool>(n));

    vvi act(n);
    V<pair<int, int>> ans;

    repv(i, st) {
        repv(j, graph[i]) {
            if (rem[i][j]) {
                continue;
            }

            act[i].push_back(j);
            act[j].push_back(i);
            ans.emplace_back(i + 1, j + 1);
            rem[i][j] = true;
        }

        repv(j, inv[i]) {
            rep(k, n) {
                rem[j][k] = rem[j][k] || rem[i][k];
            }
        }
    }
    fill(all(vis), false);

    function<bool(int, int)> test = [&](int i, int p) {
        vis[i] = true;
        repv(j, act[i]) {
            if (j == p) {
                continue;
            }

            if (vis[j]) {
                return false;
            }

            if (!test(j, i)) {
                return false;
            }
        }

        return true;
    };

    if (!test(0, 0)) {
        cout << "No\n";
        return;
    }

    cout << "Yes\n";
    repv(i, ans) {
        cout << i.first << ' ' << i.second << '\n';
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    pre();

    int t;
    (TEST && cin >> t) || (t = 1);
    while (t--) {
        solve();
    }
}
